﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ClassSamples;
using System.Drawing;
using Geometrical_Figures;

namespace ConsoleWithClasses
{
    /// <summary>
    /// Класс с тестами методов
    /// классов DLL ClassSamples
    /// </summary>
    class Testing
    {
        
        public void TestCreateRational()
        {
            try
            {
                 SRational r1 = new SRational(-5, -25);
                 Console.WriteLine("r1 = " + r1.ToString());
                 SRational r2 = new SRational();
                 Console.WriteLine("r2 = " + r2.ToString());
                 SRational r3 = new SRational(4, -8);
                 Console.WriteLine("r3 = " + r3.ToString());  
                 SRational r4 = new SRational(2, 6); 
                 Console.WriteLine("r4 = " + r4.ToString()); 
                 SRational r5 = new SRational(0, 0);
                 Console.WriteLine("r5 = " + r5.ToString());
            }
            catch (RationalException e)
            {
                Console.WriteLine(e.Message);
            }
        }
        public void TestOperRational()
        {
            SRational r1 = new SRational(1, 2), 
                r2 = new SRational(1, 3);
            SRational r3, r4, r5, r6;
            r3 = r1 - r2; r4 = r1 * r2; r5 = r1 / r2; 
            r6 = (r3 + r4) * (r5 - r3)/r4;
            Console.WriteLine("r1 = " + r1.ToString());
            Console.WriteLine("r2 = " + r2.ToString());
            Console.WriteLine("r3 = " + r3.ToString());
            Console.WriteLine("r4 = " + r4.ToString());
            Console.WriteLine("r5 = " + r5.ToString());
            Console.WriteLine("r6 = " + r6.ToString());
        }
        public void TestRationalConst()
        {
            SRational r1 = new SRational(0, 8), r2 = new SRational(2, 5);
            SRational r3 = new SRational(4, 10), r4 = new SRational(3, 7);
            SRational r5 = SRational.ZERO, r6, r7;
            if ((r1 != SRational.ZERO) && (r2 == r3)) 
                r6 = (r3 + SRational.ONE) * r4;
            else r6 = SRational.ONE + SRational.ONE;
            if ((r6 > r3) && (r4 > 0.5)) r7 = r1; 
            else r7 = r2;
            Console.WriteLine("r1 = " + r1.ToString());
            Console.WriteLine("r2 = " + r2.ToString());
            Console.WriteLine("r3 = " + r3.ToString());
            Console.WriteLine("r4 = " + r4.ToString());
            Console.WriteLine("r5 = " + r5.ToString());
            Console.WriteLine("r6 = " + r6.ToString());
            Console.WriteLine("r7 = " + r7.ToString());
        }
        public void TestTwoSemantics()
        {
            Rational r1 = new Rational(5, 7),
            r2 = new Rational(12, 36), r3, r4;
            r3 = r1; r4 = r3;
            r3 = r1 + r2;
            Console.WriteLine("Класс Rational");
            Console.WriteLine("r1 = " + r1.ToString());
            Console.WriteLine("r2 = " + r2.ToString());
            Console.WriteLine("r3 = " + r3.ToString());
            Console.WriteLine("r4 = " + r4.ToString());

            SRational sr1 = new SRational(5, 7),
            sr2 = new SRational(12, 36), sr3, sr4;
            sr3 = sr1; sr4 = sr3;
            sr3 = sr1 + sr2;
            Console.WriteLine("Структура SRational");
            Console.WriteLine("sr1 = " + sr1.ToString());
            Console.WriteLine("sr2 = " + sr2.ToString());
            Console.WriteLine("sr3 = " + sr3.ToString());
            Console.WriteLine("sr4 = " + sr4.ToString());
        }
        public void TwoSemantics()
        {
            SRational sr1 = new SRational(1, 3), 
                sr2 = new SRational(3, 5);
            SRational sr3, sr4;
            sr3 = sr1 + sr2; sr4 = sr3;
            if (sr3 > 1) sr3 = sr1 + sr3 + SRational.ONE; 
            else sr3 = sr2 + sr3 - SRational.ONE;
            Console.WriteLine("Структура SRational");
            Console.WriteLine("sr1 = " + sr1.ToString());
            Console.WriteLine("sr2 = " + sr2.ToString());
            Console.WriteLine("sr3 = " + sr3.ToString());
            Console.WriteLine("sr4 = " + sr4.ToString());
        }
        public void TestPointAndSize()
        {
            Point pt1 = new Point(3, 5), pt2 = new Point(7, 10), pt3;
            PointF pt4 = new PointF(4.55f, 6.75f);
            Size sz1 = new Size(10, 20), sz2;
            SizeF sz3 = new SizeF(10.3f, 20.7f);
            pt3 = Point.Round(pt4);
            sz2 = new Size(pt1);
            Console.WriteLine("pt1: " + pt1);
            Console.WriteLine("sz2 = new Size(pt1): " + sz2);
            Console.WriteLine("pt4: " + pt4);
            Console.WriteLine("pt3 = Point.Round(pt4): " + pt3);
            pt1.Offset(5, 7);
            Console.WriteLine("pt1.Offset(5,7): " + pt1);
            Console.WriteLine("pt2: " + pt2);
            pt2 = pt2 + sz2;
            Console.WriteLine("pt2= pt2+ sz2: " + pt2);
        }//TestPointAndSize
        
        public void TestClassAndStructPoint()
        {
            string s = "Структуры: присваивание развернутого типа!";
            Console.WriteLine(s);
            Point pt1 = new Point(3, 5), pt2;
            pt2 = pt1;
            Console.WriteLine("pt1: " + pt1);
            Console.WriteLine("pt2 = pt1: " + pt2);
            pt1.Offset(5, 7);
            Console.WriteLine("pt1.Offset(5,7): " + pt1);
            Console.WriteLine("pt2: " + pt2);
            s = "Классы: присваивание ссылочного типа!";
            Console.WriteLine(s);
            CPoint cpt1 = new CPoint(3, 5), cpt2;
            cpt2 = cpt1;
            Console.WriteLine("cpt1: " + cpt1);
            Console.WriteLine("cpt2=cpt1: " + cpt2);
            cpt1.Offset(5, 7);
            Console.WriteLine("cpt1.Offset(5,7): " + cpt1);
            Console.WriteLine("cpt2: " + cpt2);
        }




    }
}
