﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ClassLibraryGeometry;

namespace WindowsGeometry
{
    public partial class FormPoint : Form
    {
        PointD ptA, ptB;
        double xA = 0, yA = 0, xB = 0, yB = 0;
        const string DATA_ERROR =
            "Некорректно заданы координаты точки!";
        const string DATA_OK =
            "Точка создана!";
        const string DISTANCE_OK =
            "Расстояние вычислено!";
        const double RAD_TO_GRAD = 180 / Math.PI;
        public FormPoint()
        {
            InitializeComponent();
        }

        private void buttonInput_XY_Click(object sender, EventArgs e)
        {
            textBoxX_A.ReadOnly = false;
            textBoxY_A.ReadOnly = false;
            textBoxFi_A.Text = "";
            textBoxR_A.Text = "";
            textBoxR_A.ReadOnly = true;
            textBoxFi_A.ReadOnly = true;
        }

        private void buttonInputRFi_Click(object sender, EventArgs e)
        {
            textBoxR_A.ReadOnly = false;
            textBoxFi_A.ReadOnly = false;
            textBoxX_A.Text = "";
            textBoxY_A.Text = "";
            textBoxX_A.ReadOnly = true;
            textBoxY_A.ReadOnly = true;
        }

        private void buttonCreatePoint_A_Click(object sender, EventArgs e)
        {
            double x = 0, y = 0, r = 0, fi = 0;
            if (textBoxX_A.ReadOnly == false)
            {
                try
                {
                    x = double.Parse(textBoxX_A.Text);
                    y = double.Parse(textBoxY_A.Text);
                    ptA = new PointD(x, y);
                    r = ptA.R; fi = ptA.FI;
                    fi *= RAD_TO_GRAD;
                    textBoxR_A.Text = r.ToString();
                    textBoxFi_A.Text = fi.ToString();
                    textBoxRezult.Text = DATA_OK;
                }
                catch (Exception)
                {
                    textBoxRezult.Text = DATA_ERROR;
                }
            }
            else
            {
                try
                {
                    r = double.Parse(textBoxR_A.Text);
                    fi = double.Parse(textBoxFi_A.Text);
                    fi /= RAD_TO_GRAD; 
                    ptA = new PointD(r, fi,"Polar");
                    x = ptA.X; y = ptA.Y;
                    
                    textBoxX_A.Text = x.ToString();
                    textBoxY_A.Text = y.ToString();
                    textBoxRezult.Text = DATA_OK;
                }
                catch (Exception)
                {
                    textBoxRezult.Text = DATA_ERROR;
                }
            }
            xA = x; yA = y;
        }

        private void buttonInputXY_B_Click(object sender, EventArgs e)
        {
            textBoxX_B.ReadOnly = false;
            textBoxY_B.ReadOnly = false;
            textBoxFi_B.Text = "";
            textBoxR_B.Text = "";
            textBoxR_B.ReadOnly = true;
            textBoxFi_B.ReadOnly = true;
        }

        private void buttonInputRFi_B_Click(object sender, EventArgs e)
        {
            textBoxR_B.ReadOnly = false;
            textBoxFi_B.ReadOnly = false;
            textBoxX_B.Text = "";
            textBoxY_B.Text = "";
            textBoxX_B.ReadOnly = true;
            textBoxY_B.ReadOnly = true;
        }

        private void buttonCreatePoint_B_Click(object sender, EventArgs e)
        {
            double x = 0, y = 0, r = 0, fi = 0;
            if (textBoxX_B.ReadOnly == false)
            {
                try
                {
                    x = double.Parse(textBoxX_B.Text);
                    y = double.Parse(textBoxY_B.Text);
                    ptB = new PointD(x, y);
                    r = ptB.R; fi = ptB.FI;
                    fi *= RAD_TO_GRAD;
                    textBoxR_B.Text = r.ToString();
                    textBoxFi_B.Text = fi.ToString();
                    textBoxRezult.Text = DATA_OK;
                }
                catch (Exception)
                {
                    textBoxRezult.Text = DATA_ERROR;
                }
            }
            else
            {
                try
                {
                    r = double.Parse(textBoxR_B.Text);
                    if (r < 0) throw new Exception();
                    fi = double.Parse(textBoxFi_B.Text);
                    fi /= RAD_TO_GRAD;
                    ptB = new PointD(r, fi, "Polar");
                    x = ptB.X; y = ptB.Y;

                    textBoxX_B.Text = x.ToString();
                    textBoxY_B.Text = y.ToString();
                    textBoxRezult.Text = DATA_OK;
                }
                catch (Exception)
                {
                    textBoxRezult.Text = DATA_ERROR;
                }
            }
            xB = x; yB = y;

        }

        private void buttonDistance_Click(object sender, EventArgs e)
        {
            try
            {
                double d = (xA - xB) * (xA - xB) +
                    (yA - yB) * (yA - yB);
                d = Math.Sqrt(d);
                textBoxDistance.Text = d.ToString();
                textBoxRezult.Text = DISTANCE_OK;
            }
            catch (Exception)
            {
                textBoxDistance.Text = "";
                textBoxRezult.Text = DATA_ERROR;
            }
        }

        

       
    }
}
