﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ClassLibraryGeometry;

namespace WindowsGeometry
{
    public partial class FormVector : Form
    {
        VectorD vector1, vector2;
        PointD ptA1, ptA2, ptB1, ptB2;
        double xA1 = 0, yA1 = 0, xB1 = 0, yB1 = 0;
        double xA2 = 0, yA2 = 0, xB2 = 0, yB2 = 0;

        const string DATA_ERROR =
            "Некорректно заданы координаты точки!";
        const string POINT_OK =
            "Точка создана!";
        const string VECTOR_OK =
           "Вектор создан!";
        const string DISTANCE_OK =
            "Расстояние вычислено!";
        const double RAD_TO_GRAD = 180 / Math.PI;
        public FormVector()
        {
            InitializeComponent();
        }

        private void buttonInput_XY1_Click(object sender, EventArgs e)
        {
            textBoxX_A1.ReadOnly = false;
            textBoxY_A1.ReadOnly = false;
            textBoxFi_A1.Text = "";
            textBoxR_A1.Text = "";
            textBoxR_A1.ReadOnly = true;
            textBoxFi_A1.ReadOnly = true;

        }

        private void buttonInputRFi1_Click(object sender, EventArgs e)
        {
            textBoxR_A1.ReadOnly = false;
            textBoxFi_A1.ReadOnly = false;
            textBoxX_A1.Text = "";
            textBoxY_A1.Text = "";
            textBoxX_A1.ReadOnly = true;
            textBoxY_A1.ReadOnly = true;
        }

        private void buttonCreatePoint_A1_Click(object sender, EventArgs e)
        {
            double x = 0, y = 0, r = 0, fi = 0;
            if (textBoxX_A1.ReadOnly == false)
            {
                try
                {
                    x = double.Parse(textBoxX_A1.Text);
                    y = double.Parse(textBoxY_A1.Text);
                    ptA1 = new PointD(x, y);
                    r = ptA1.R; fi = ptA1.FI;
                    fi *= RAD_TO_GRAD;
                    textBoxR_A1.Text = r.ToString();
                    textBoxFi_A1.Text = fi.ToString();
                    textBoxRezult1.Text = POINT_OK;
                }
                catch (Exception)
                {
                    textBoxRezult1.Text = DATA_ERROR;
                }
            }
            else
            {
                try
                {
                    r = double.Parse(textBoxR_A1.Text);
                    fi = double.Parse(textBoxFi_A1.Text);
                    fi /= RAD_TO_GRAD;
                    ptA1 = new PointD(r, fi, "Polar");
                    x = ptA1.X; y = ptA1.Y;

                    textBoxX_A1.Text = x.ToString();
                    textBoxY_A1.Text = y.ToString();
                    textBoxRezult1.Text = POINT_OK;
                }
                catch (Exception)
                {
                    textBoxRezult1.Text = DATA_ERROR;
                }
            }
            xA1 = x; yA1 = y;
        }        

        private void buttonInput_XYB1_Click(object sender, EventArgs e)
        {
            textBoxX_B1.ReadOnly = false;
            textBoxY_B1.ReadOnly = false;
            textBoxFi_B1.Text = "";
            textBoxR_B1.Text = "";
            textBoxR_B1.ReadOnly = true;
            textBoxFi_B1.ReadOnly = true;
        }

        private void buttonInput_RFiB1_Click(object sender, EventArgs e)
        {
            textBoxR_B1.ReadOnly = false;
            textBoxFi_B1.ReadOnly = false;
            textBoxX_B1.Text = "";
            textBoxY_B1.Text = "";
            textBoxX_B1.ReadOnly = true;
            textBoxY_B1.ReadOnly = true;

        }

        private void buttonCreateB1_Click(object sender, EventArgs e)
        {
            double x = 0, y = 0, r = 0, fi = 0;
            if (textBoxX_A1.ReadOnly == false)
            {
                try
                {
                    x = double.Parse(textBoxX_A1.Text);
                    y = double.Parse(textBoxY_A1.Text);
                    ptA1 = new PointD(x, y);
                    r = ptA1.R; fi = ptA1.FI;
                    fi *= RAD_TO_GRAD;
                    textBoxR_A1.Text = r.ToString();
                    textBoxFi_A1.Text = fi.ToString();
                    textBoxRezult1.Text = POINT_OK;
                }
                catch (Exception)
                {
                    textBoxRezult1.Text = DATA_ERROR;
                }
            }
            else
            {
                try
                {
                    r = double.Parse(textBoxR_A1.Text);
                    fi = double.Parse(textBoxFi_A1.Text);
                    fi /= RAD_TO_GRAD;
                    ptA1 = new PointD(r, fi, "Polar");
                    x = ptA1.X; y = ptA1.Y;

                    textBoxX_A1.Text = x.ToString();
                    textBoxY_A1.Text = y.ToString();
                    textBoxRezult1.Text = POINT_OK;
                }
                catch (Exception)
                {
                    textBoxRezult1.Text = DATA_ERROR;
                }
            }
            xA1 = x; yA1 = y;

        }

        private void buttonCreateVector1_Click(object sender, EventArgs e)
        {

            try
            {
                vector1 = new VectorD(ptA1, ptB1);
                textBoxRezult1.Text = VECTOR_OK;
            }
            catch (Exception)
            {
                textBoxRezult1.Text = DATA_ERROR;
            }
        }        
    }
}
